#include <sys/time.h>
#include <stdlib.h>                      
#include <math.h>
#include <stdio.h>

struct timeval tv;                      
int *ar1; /*Arreglo que se decea ordenar*/
int sizearr;                            

main(int argc, char *argv[])                            
{         
   int i, j, n_veces =10; /*n_veces nmero de repeticiones del ciclo de ordenamiento */                                                      
   double desv;                                              
   double t_inicial, t_final, t_ordenamiento, t_promedio, t_total, t_total_2; /*Variables para manejo del tiempo*/
   
   sizearr=atoi(argv[1]); /* se obtiene el tamao del arreglo a ordenar*/  
   
   printf("\n---------------------------------------------\n"); 
   printf(" Ordenamiento de 10 arreglos de tamao %d \n",sizearr);   
   printf("---------------------------------------------\n");
   
   srand(time(0)); /*se inicializa la semilla para el random*/
   
   for(j=0;j<10;j++) /*10 ciclos de ordenamiento*/
     {       
	ar1  = (int *)malloc( sizearr*sizeof(int) ); /*Reserva espacio en memoria de tamao "sizearr"*/
	
	for( i=0; i<sizearr; i++ )
	  {    
	     ar1[i]=rand() % 100; /*ciclo de llenado del arreglo a ordenar*/
	  }
	
	gettimeofday(&tv, 0);   /*Se registra el tiempo de inicio*/
	t_inicial=(tv.tv_sec)*1000000 + (tv.tv_usec)/1;
	
	ordenar(ar1,sizearr); /*Invoca a funcion ordenar*/     
	
	gettimeofday(&tv, 0);  /*Se registra el tiempo de termino*/ 
	t_final=(tv.tv_sec)*1000000 + (tv.tv_usec)/1;
	
	free (ar1);   /*Liberamos espacio en memoria destinado al arreglo*/
	
	t_ordenamiento= (t_final - t_inicial); /*obtenemos el tiempo de ordenamiento*/
	
	t_total += (t_ordenamiento);           /*Tiempo total de los 10 ordenamientos*/
	t_total_2 +=( t_ordenamiento*t_ordenamiento);          
     }
   
   t_promedio=(t_total)/(n_veces);  /*promedio*/
   
   desv=sqrt((t_total_2-(n_veces*t_promedio*t_promedio))/(n_veces-1));  /*desviacion estandar*/
   
   /*se imprime por pantalla la informacion de proceso*/
   printf(" Tiempo promedio \t Desviacion estandar\n\n");    
   printf("    %.3f us\t\t\t%.3f\n",t_promedio,desv); 
   printf("---------------------------------------------\n\n\n");
   return(0);                                                             
}
